<?php
/*-----------------------------------------------------------------------------
  pWebFTP
  -------
  Dateimanager auf PHP Basis
  --------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pWebFTP ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.
    
    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:
    14.01.2006 Pr0g v1.9 -Einstellung fr HTML Host eingefgt
                         -Readonly Modus integriert
                         -Kodieren von HTML Codes beim Bearbeiten, um Fehler in
                          der Textarea zu verhindern
                         -Weitere Fehlerbehandlungen eingefgt
                         -Auch nicht klein geschriebene Dateiendungen dem
                          passenden Typen zuordnen
               Muetze1   -Unterdrckung von Fehlern beim ffnen von Ordnern und
                          anderen Aktionen, die bei fehlenden Rechten auftraten
  
    06.12.2005 Pr0g v1.8 -Fehler beim Erstellen eines Ordners behoben
  
    12.11.2005 Pr0g v1.7 -Fehler beim Sortieren nach nderungsdatum behoben
    
    14.09.2005 Pr0g v1.6 -Fehler beim FTP Support behoben
                         -Popup nun grenvernderbar
                         -Updatekontrolle integriert
    
    31.08.2005 Pr0g v1.5 -Beim Verschieben/Lschen die ausgewhlte(n) Datei(en)
                          auflisten
                         -Lschabfrage durch "Ja"/"Nein" Button
                         -Baumstruktur beim Verschieben zur Auswahl des Ziel-
                          ordners anzeigen
                         -Datei-/Codeansicht wahlweise im Popup anzeigen
                         -Verschieben- und Lschsymbol fr einzelne Dateien
                          hinzugefgt
                         -Textlinks/Buttons in neue Toolbar eingefgt
                         -XHTML Code validiert
                         
    25.08.2005 Pr0g v1.4 -Anzahl der Dateien und Gesamtgre unter Dateiauf-
                          listung hinzugefgt
                          
    20.08.2005 Pr0g v1.3 -FTP Support zum Anlegen von Ordnern hinzugefgt damit
                          es keine Probleme bei einem aktiven und falsch konfi-
                          gurierten safe_mode gibt
                          
    18.08.2005 Pr0g v1.2 -Zugriffsrechte fr neu erstellte Ordner hher gesetzt
                         -Dateityp "exe" hinzugefgt
                         
    18.08.2005 Pr0g v1.1 -Verschieben und Lschen mehrere Dateien gleichzeitig
                         -Dateityp "bmp" hinzugefgt
                         -Originale Icons fr "7z" und "zip" hinzugefgt
                         
    18.08.2005 Pr0g v1.0 -Erstes Release
-----------------------------------------------------------------------------*/

  // Ausgabe Puffern um zwischendurch noch mit den Sessions arbeiten zu knnen
  ob_start();
  
  // Sessions starten
  session_start();

  // Konfiguration einbinden
  require('config.php');
  
  // Prfen, ob ein Rootverzeichnis angegeben wurde
  if (!file_exists($root_dir)) {
    die('Fehler: Sie m&uuml;ssen in der Datei "config.php" ein g&uuml;ltiges Rootverzeichnis angeben!');
  }
  
  // Ebenenwechsel verhindern
  $_GET['dir'] = str_replace('..', '', $_GET['dir']);
  if (isset($_GET['file'])) {
    $_GET['file'] = str_replace('..', '', $_GET['file']);
  }

  // Prfen, ob der gewhlte Ordner vorhanden ist
  if (!file_exists($root_dir . '/' . $_GET['dir'])) {
    $_GET['dir'] = '';
  }
  
  // Prfen, ob die gewhlte Datei vorhanden ist
  if (!file_exists($root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_GET['file'])) {
    $_GET['file'] = '';
  }

  // Dateierweiterung ermitteln
  function GetFileExt($file) {
    $file = basename($file);
    if (strpos($file, '.') === false) {
      return '?';
    }
    $ext = '';
    for ($i = strlen($file); $i > 0; $i--) {
      if ($file[$i] == '.') {
        break;
      }
      $ext = $file[$i] . $ext;
    }
    return strtolower($ext);
  }

  // Dateisymbol ermitteln
  function GetFileSymbol($ext) {
    global $file_types;

    $symbol = $file_types[$ext][1];
    if (empty($symbol)) {
      $symbol = 'unknown.gif';
    }
    return $symbol;
  }

  // Eine Fehlermeldung ausgeben
  function DisplayErrorMsg($msg) {
    global $error_display_time;
    header('refresh: ' . $error_display_time . '; url=index.php?dir=' . urlencode($_GET['dir']));
    echo '<br /><span class="error_msg">' . $msg . ', Sie werden in ' . $error_display_time . ' Sekunden zum Index zurckgeleitet.<span>';
  }

  // Prfen, ob eine Datei angezeigt werden soll
  if (isset($_GET['file'])) {
    $filename = '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_GET['file'];
    if (!isset($_GET['action'])) {
      header('location: ' . (empty($html_host) ? $root_dir : $html_host) . $filename);
    } elseif ($_GET['action'] == 'show_source') {
      if (in_array(GetFileExt($_GET['file']), $files_phpsyn)) {
        highlight_file($root_dir . $filename);
      } else {
        echo '<code>';
        echo nl2br(htmlspecialchars(file_get_contents($root_dir . $filename)));
        echo '</code>';
      }
      die;
    }
  }
  
  // Versionsnummer
  $version = '1.9';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="de" xml:lang="de">
<head>
<title>pWebFTP v<?=$version?> by pr0g.net</title>
<link rel="stylesheet" type="text/css" href="style.css" />
<?php
  if ($open_popup) {
?>
<script type="text/javascript">
function popup(url) {
  window.open(url, '_blank', 'innerHeight=<?=$popup_height?>,innerWidth=<?=$popup_width?>,location=no,menubar=no,resizable=yes,scrollbars=yes,status=yes,toolbar=no');
}
</script>
<?php
  }
?>
</head>
<body>
<?php
  $actions = array('upload', 'new_txt', 'new_dir', 'rename_dir', 'delete_dir', 'edit_file', 'rename_file', 'file_move_delete', 'update');
  if (!in_array($_GET['action'], $actions)) {
    $noaction = true;
    echo '<form action="?dir=' . urlencode($_GET['dir']) . '&amp;action=file_move_delete" method="post" style="height:100%">';
  }
?>
<table class="tbl_main">
<tr>
 <td class="td_menu_top">
 <table class="tbl_toolbar">
 <tr>
  <td><a name="top" id="top"><img src="gfx/menu_left.gif" alt="" /></a></td>
  <td style="width:100%"><b>&nbsp;pWebFTP v<?=$version?> by <a href="http://pr0g.net" class="a_pr0g">pr0g.net</a></b></td>
 </tr>
 </table>
 </td>
 <td class="td_content_top">
  <table class="tbl_toolbar">
  <tr>
   <td><img src="gfx/menu_left.gif" alt="" /></td>
<?php
  if ($noaction) {
?>
   <td><a class="a_toolbtn" href="?dir=<?=urlencode($_GET['dir'])?>&amp;action=upload"><img src="gfx/file_upload.gif" title="Neue Datei hochladen" alt="" /></a></td>
   <td><a class="a_toolbtn" href="?dir=<?=urlencode($_GET['dir'])?>&amp;action=new_txt"><img src="gfx/file_new.gif" title="Neue Textdatei anlegen" alt="" /></a></td>
   <td>&nbsp;</td>
   <td><a class="a_toolbtn" href="?dir=<?=urlencode($_GET['dir'])?>&amp;action=new_dir"><img src="gfx/folder.gif" title="Neuen Ordner anlegen" alt="" /></a></td>
   <td>&nbsp;</td>
<?php
    if (!in_array(basename($root_dir . '/' . $_GET['dir']), $readonly)) {
?>
   <td><a class="a_toolbtn" href="?dir=<?=urlencode($_GET['dir'])?>&amp;action=rename_dir"><img src="gfx/file_rename.gif" title="Ordner umbennen" alt="" /></a></td>
   <td style="padding-right:20px;border-right:1px solid #CBC9D1"><a class="a_toolbtn" href="?dir=<?=urlencode($_GET['dir'])?>&amp;action=delete_dir"><img src="gfx/file_delete.gif" title="Ordner l&ouml;schen" alt="" /></a></td>
<?php
    } else {
      echo '<td>&nbsp;</td><td style="padding-right:6px;border-right:1px solid #CBC9D1">&nbsp;</td>';
    }
?>
   <td><img src="gfx/menu_left.gif" alt="" /></td>
   <td style="white-space:nowrap">&nbsp;Markierte Dateien:&nbsp;</td>
   <td><input type="image" src="gfx/file_move.gif" name="send_move" title="verschieben" alt="" /></td>
   <td>&nbsp;oder&nbsp;</td>
   <td style="width:100%;border-right:1px solid #CBC9D1"><input type="image" src="gfx/file_delete.gif" name="send_delete" title="l&ouml;schen" alt="" /></td>
   <td><img src="gfx/menu_left.gif" alt="" /></td>
   <td style="padding-right:20px;"><a class="a_toolbtn" href="?action=update"><img src="gfx/menu_update.gif" title="Versionskontrolle durchfhren" alt="" /></a></td>
<?php
  } else {
    echo '<td style="width:100%">&middot; <a href="?dir=' . urlencode($_GET['dir']) . '" class="a_back">Zur&uuml;ck</a></td>';
  }
?>
  </tr>
  </table>
 </td>
</tr>
<tr>
 <td class="td_menu">
 <div class="div_menu" style="white-space:nowrap;">
 <img src="gfx/folderopen.gif" alt="" /> <?=CreateLink($root_dir . '/')?><br />
<?php
  // Alle Knoten zum gewhlten Ordner ausklappen
  function CheckOpen($dir) {
    global $root_dir;
    
    $dirs = explode('/', $dir);
    $path = $root_dir;
    for ($i = 0; $i < count($dirs); $i++) {
      $path .= '/' . $dirs[$i];
      $_SESSION[$path] = true;
    }
  }
  // Verbindungslinie der Eintrge erzeugen
  function Line($n, $middle, $last = false) {
    $line = '';
    if ($n > 0) {
      $line .= '<img src="gfx/' . ($last ? 'empty' : 'line') . '.gif" alt="" />';
    }
    for ($i = 1; $i < $n; $i++) {
      $line .= '<img src="gfx/' . (($middle[$i]) ? 'line' : 'empty') . '.gif" alt="" />';
    }
    return $line;
  }

  // Einen Link der Baumstruktur erzeugen
  function CreateLink($dir, $nolink = false, $move_tree = false) {
    global $root_dir;
    
    $root_len = strlen($root_dir) + 1;
    $noroot = substr($dir, $root_len, strlen($dir) - $root_len);

    if ($move_tree) {
      return basename($dir) . ' <input class="input_move_tree" type="radio" name="targetdir" value="' . $noroot . '" />';
    } else {
      if (!$nolink) {
        $style = ($root_dir . '/' . $_GET['dir'] == $dir) ? ' class="a_active"' : '';
        return '<a href="?dir=' . urlencode($noroot) . '"' . $style . '>' . basename($dir) . '</a>';
      } else {
        return basename($dir);
      }
    }
  }

  // Alle Unterordner eines Verzeichnisses als Array zurckgeben
  function GetDirs($dir) {
    $dirs = array();
    $dir .= '/';
    if ($dh = @opendir($dir)) {
      while ($dir_name = readdir($dh)) {
        if (is_dir($dir . $dir_name) && $dir_name != '.' && $dir_name != '..') {
          $dirs[] = $dir . $dir_name;
        }
      }
      closedir($dh);
      sort($dirs);
      return $dirs;
    } else {
      return -1;
    }
  }

  // Baumstruktur erzeugen
  function CreateTree($dir, $move_tree = false, $section = 0, $middle = array(true), $last = false) {
    global $root_dir;
  
    if ($dirs = GetDirs($dir)) {
      $count = count($dirs);
      for ($i = 0; $i < $count; $i++) {
        $tempcount = GetDirs($dirs[$i]);
        $dirs[$i] = array($dirs[$i], (($tempcount != -1) ? count($tempcount) : -1));
        if ($dirs[$i][1] > 0) {
          if ($_GET['file'] == $data[$i][1]) {
            $_SESSION[$data[$i][1]] = 1;
          }
          $bottom = (isset($dirs[$i + 1])) ? '' : 'bottom';
          $root_len = strlen($root_dir) + 1;
          $link_dir = urlencode(substr($dirs[$i][0], $root_len, strlen($dirs[$i][0]) - $root_len));
          if (isset($_SESSION[$dirs[$i][0]]) || $move_tree) {
            if (($i == $count - 1) && ($section == 0)) {
              $last = true;
            }
            echo Line($section, $middle, ($section == 0 ? false : $last)) . ($move_tree ? '' : '<a href="index.php?dir=' . $link_dir . '&amp;close=true" class="a_pm">') . '<img src="gfx/minus' . $bottom . '.gif" alt="" />' . ($move_tree ? '' : '</a>') . '<img src="gfx/folderopen.gif" alt="" /> ' . CreateLink($dirs[$i][0], $move_tree) . '<br />';
            $middle[$section] = ($i < $count - 1);
            CreateTree($dirs[$i][0], $move_tree, $section + 1, $middle, $last);
          } else {
            echo Line($section, $middle, $last) . '<a href="index.php?dir=' . $link_dir . '" class="a_pm"><img src="gfx/plus' . $bottom . '.gif" alt="" /></a><img src="gfx/folder.gif" alt="" /> ' . CreateLink($dirs[$i][0]) . '<br />';
          }
        } else {
          $bottom = ($i == $count - 1) ? 'bottom' : '';
          echo Line($section, $middle, $last) . '<img src="gfx/join' . $bottom . '.gif" alt="" /><img src="gfx/folder' . ($root_dir . '/' . $_GET['dir'] == $dirs[$i][0] ? 'open' : '') . '.gif" alt="" /> ' . CreateLink($dirs[$i][0], ($dirs[$i][1] === -1), $move_tree) . '<br />';
        }
      }
    }
  }

  if (isset($_GET['close'])) {
    // Den gewhlten Knoten einklappen
    unset($_SESSION[$root_dir . '/' . $_GET['dir']]);
  } elseif (isset($_GET['dir'])) {
    // Alle Knoten zum gewhlten Ordner aufklappen
    CheckOpen($_GET['dir']);
  }

  // Ordnerstruktur erzeugen und ausgeben
  CreateTree($root_dir);
?>
 </div>
 </td>
 <td rowspan="2" class="td_content">
  <br />
<?php
  // Ausgabeaktion whlen
  if ($_GET['action'] == 'upload') {
    // Datei hochladen
    if (empty($_FILES['upload']['tmp_name'])) {
?>
Bitte geben Sie die Datei an, welche hochgeladen werden soll:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=upload" method="post" enctype="multipart/form-data">
<input type="file" name="upload" /><br />
<br />
<input type="submit" value="Datei hochladen" />
</form>
<?php
    } else {
      $local_file = $root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_FILES['upload']['name'];
      if (move_uploaded_file($_FILES['upload']['tmp_name'], $local_file)) {
        if (chmod($local_file, 0666)) {
          header('location: index.php?dir=' . urlencode($_GET['dir']));
        } else {
          DisplayErrorMsg('Beim Setzen neuer Rechte fr die hochgeladene Datei trat ein Fehler auf');
        }
      } else {
        DisplayErrorMsg('Beim Verschieben der hochgeladenen Datei trat ein Fehler auf');
      }
    }
  } elseif ($_GET['action'] == 'new_txt') {
    // Textdatei anlegen
    if (empty($_POST['filename'])) {
?>
Bitte geben Sie einen Dateinamen mit Endung und eventuell direkt den Inhalt der neuen Datei an:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=new_txt" method="post">
Dateiname: <input type="text" name="filename" /><br />
<br />
Dateiinhalt:<br />
<textarea name="filedata" style="width:500px;height:300px"><?=$_POST['filedata']?></textarea><br />
<br />
<input type="submit" value="Datei anlegen" />
</form>
<?php
    } else {
      $local_file = $root_dir . (empty($_GET['dir']) ? '' : '/' . $_GET['dir']) . '/' . $_POST['filename'];;
      if ($fp = fopen($local_file, 'w-')) {
        fputs($fp, stripslashes($_POST['filedata']));
        fclose($fp);
        if (chmod($local_file, 0666)) {
          header('location: index.php?dir=' . urlencode($_GET['dir']));
        } else {
          DisplayErrorMsg('Beim Setzen neuer Rechte f&uuml;r die neue Datei trat ein Fehler auf');
        }
      } else {
        DisplayErrorMsg('Beim Anlegen der neuen Datei trat ein Fehler auf');
      }
    }
  } elseif ($_GET['action'] == 'new_dir') {
    // Ordner anlegen
    if (empty($_POST['dirname'])) {
?>
Bitte geben Sie den Namen des neuen Ordners an:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=new_dir" method="post">
Ordnername: <input type="text" name="dirname" /><br />
<br />
<input type="submit" value="Ordner anlegen" />
</form>
<?php
    } else {
      $local_file = '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_POST['dirname'];
      $old_umask = umask(0);
      if ($use_ftp) {
        $ftpc = ftp_connect($ftp_hostserver);
        ftp_login($ftpc, $ftp_username, $ftp_password);
        ftp_mkdir($ftpc, $ftp_rootdir . $local_file);
        ftp_site($ftpc, 'CHMOD 0777 ' . $ftp_rootdir . $local_file);
        ftp_quit($ftpc);
      } else {
        if (!mkdir($root_dir . $local_file, 0777)) {
          umask($old_umask);
          DisplayErrorMsg('Beim Anlegen des Ordners trat ein Fehler auf');
        }
      }
      umask($old_umask);
      header('location: index.php?dir=' . urlencode($_GET['dir']));
    }
  } elseif ($_GET['action'] == 'rename_dir') {
    // Ordner umbenennen
    if (empty($_POST['dirname'])) {
    
?>
Bitte geben Sie einen neuen Namen fr den Ordner an:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=rename_dir" method="post">
Ordnername: <input type="text" name="dirname" /><br />
<br />
<input type="submit" value="Ordner umbennen" />
</form>
<?php
    } else {
      $new_dirname = str_replace(basename($_GET['dir']), $_POST['dirname'], $_GET['dir']);
      if (rename($root_dir . '/' . $_GET['dir'], $root_dir . '/' . $new_dirname)) {
        header('location: index.php?dir=' . urlencode($new_dirname));
      } else {
        DisplayErrorMsg('Beim Umbennen des Ordners trat ein Fehler auf');
      }
    }
  } elseif ($_GET['action'] == 'delete_dir') {
    // Ordner lschen
    if (!isset($_POST['delete'])) {
      if (isset($_POST['nodelete'])) {
        header('location: index.php?dir=' . urlencode($_GET['dir']));
      }
?>
Sicher, dass der Ordner mit allen Unterordnern und Dateien gel&ouml;scht werden soll?<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=delete_dir" method="post">
<input type="submit" name="delete" value="Ja" /> <input type="submit" name="nodelete" value="Nein" />
</form>
<?php
    } else {
      // Einen Ordner mit allen Daten lschen
      function DeleteDir($dir) {
        if($objs = glob($dir . '/*')) {
          foreach($objs as $obj) {
            if (is_dir($obj)) {
              DeleteDir($obj);
            } else {
              if (!unlink($obj)) {
                DisplayErrorMsg('Beim L&ouml;schen einer Datei trat ein Fehler auf');
              }
            }
          }
        }
        if (!rmdir($dir)) {
          DisplayErrorMsg('Beim L&ouml;schen eines Ordners trat ein Fehler auf');
        }
      }
      
      DeleteDir($root_dir . '/' . $_GET['dir']);
      header('location: index.php');
    }
  } elseif ($_GET['action'] == 'edit_file') {
    // Textdatei berarbeiten
    if (!isset($_POST['send'])) {
?>
Sie haben nun die M&ouml;glichkeit den Inhalt der Datei anzupassen:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;file=<?=urlencode($_GET['file'])?>&amp;action=edit_file" method="post">
Dateiinhalt:<br />
<textarea name="filedata" style="width:500px;height:300px">
<?php
      echo htmlspecialchars(file_get_contents($root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_GET['file']));
?>
</textarea><br />
<br />
<input type="submit" name="send" value="&Auml;nderungen speichern" />
</form>
<?php
    } else {
      $local_file = $root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/') . $_GET['file'];
      if (!chmod($local_file, 0666)) {
        DisplayErrorMsg('Beim Setzen der Rechte f&uuml;r eine Datei trat ein Fehler auf');
      }
      if ($fp = fopen($local_file, 'w-')) {
        fputs($fp, stripslashes($_POST['filedata']));
        fclose($fp);
        header('location: index.php?dir=' . urlencode($_GET['dir']));
      } else {
        DisplayErrorMsg('Beim &Ouml;ffnen einer Datei trat ein Fehler auf');
      }
    }
  } elseif ($_GET['action'] == 'rename_file') {
    // Datei umbenennen
    if (empty($_POST['filename'])) {
?>
Bitte geben Sie einen neuen Namen fr die Datei an:<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;file=<?=urlencode($_GET['file'])?>&amp;action=rename_file" method="post">
Dateiname: <input type="text" name="filename" value="<?=$_GET['file']?>" /><br />
<br />
<input type="submit" value="Datei umbenennen" />
</form>
<?php
    } else {
      $file_dir = $root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/');
      if (rename($file_dir . $_GET['file'], $file_dir . $_POST['filename'])) {
        header('location: index.php?dir=' . urlencode($_GET['dir']));
      } else {
        DisplayErrorMsg('Beim Umbennen einer Datei trat ein Fehler auf');
      }
    }
  } elseif ($_GET['action'] == 'file_move_delete') {
    if (empty($_REQUEST['selfiles'])) {
      header('location: index.php?dir=' . urlencode($_GET['dir']));
    }
    if (isset($_POST['send_move_x']) || isset($_REQUEST['send_move'])) {
      // Dateien verschieben
      if (!isset($_POST['targetdir']) || !file_exists($root_dir . '/' . $_POST['targetdir'])) {
        if (!is_array($_REQUEST['selfiles'])) {
          $_REQUEST['selfiles'] = explode('[~]', $_REQUEST['selfiles']);
        }
?>
Folgende Datei<?=(count($_REQUEST['selfiles']) > 1 ? 'en werden' : ' wird')?> verschoben:<br />
<br />
<?php
        for ($i = 0; $i < count($_REQUEST['selfiles']); $i++) {
          echo '<img src="gfx/files/' . GetFileSymbol(GetFileExt($_REQUEST['selfiles'][$i])) . '" alt="" /> ' . $_REQUEST['selfiles'][$i] . '<br />';
        }
?>
<br />
<?php
        if ($move_tree) {
          echo 'Bitte w&auml;hlen Sie einen Zielordner aus der Baumstruktur:';
        } else {
          echo 'Bitte geben Sie einen g&uuml;ltigen Zielordner ausgehend vom Rootverzeichnis an:';
        }
?>
<br />
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=file_move_delete" method="post">
<input type="hidden" name="send_move" value="1" />
<input type="hidden" name="selfiles" value="<?=implode('[~]', $_REQUEST['selfiles'])?>" />
<?php
        if ($move_tree) {
          echo '<img src="gfx/folderopen.gif" alt="" /> ' . basename($root_dir) . ' <input class="input_move_tree" type="radio" name="targetdir" value="." /><br />';

          // Ordnerstruktur erzeugen und ausgeben
          CreateTree($root_dir, true);
        } else {
          echo 'Zielordner: ' . basename($root_dir) . '/ <input type="text" name="targetdir" />';
        }
?>
<br />
<input type="submit" value="Datei<?=(count($_REQUEST['selfiles']) > 1 ? 'en' : '')?> verschieben" />
</form>
<?php
      } else {
        $file_dir = $root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/');
        $target_dir = $root_dir . '/' . (empty($_POST['targetdir']) ? '' : $_POST['targetdir'] . '/');
        $filelist = explode('[~]', $_POST['selfiles']);
        for ($i = 0; $i < count($filelist); $i++) {
          if (!copy($file_dir . $filelist[$i], $target_dir . $filelist[$i])) {
            DisplayErrorMsg('Beim Kopieren einer Datei w&auml;hrend des Verschiebens trat ein Fehler auf');
          }
          if (!unlink($file_dir . $filelist[$i])) {
            DisplayErrorMsg('Beim L&ouml;schen einer Datei w&auml;hrend des Verschiebens trat ein Fehler auf');
          }
        }
        header('location: index.php?dir=' . urlencode($_GET['dir']));
      }
    } elseif (isset($_POST['send_delete_x']) || isset($_REQUEST['send_delete'])) {
      // Dateien lschen
      if (!isset($_POST['delete'])) {
        if (isset($_POST['nodelete'])) {
          header('location: index.php?dir=' . urlencode($_GET['dir']));
        }
        $en = (count($_REQUEST['selfiles']) > 1 ? 'en' : '');
?>
Sind Sie sicher, dass folgende Datei<?=$en?> gel&ouml;scht werden soll<?=$en?>:<br />
<br />
<?php
        for ($i = 0; $i < count($_REQUEST['selfiles']); $i++) {
          echo '<img src="gfx/files/' . GetFileSymbol(GetFileExt($_REQUEST['selfiles'][$i])) . '" alt="" /> ' . $_REQUEST['selfiles'][$i] . '<br />';
        }
?>
<br />
<form action="?dir=<?=urlencode($_GET['dir'])?>&amp;action=file_move_delete" method="post">
<input type="hidden" name="send_delete" value="1" />
<input type="hidden" name="selfiles" value="<?=implode('[~]', $_REQUEST['selfiles'])?>" />
<input type="submit" name="delete" value="Ja" /> <input type="submit" name="nodelete" value="Nein" />
</form>
<?php
      } else {
        $file_dir = $root_dir . '/' . (empty($_GET['dir']) ? '' : $_GET['dir'] . '/');
        $filelist = explode('[~]', $_POST['selfiles']);
        for ($i = 0; $i < count($filelist); $i++) {
          if (!unlink($file_dir . $filelist[$i])) {
            DisplayErrorMsg('Beim L&ouml;schen einer Datei trat ein Fehler auf');
          }
        }
        header('location: index.php?dir=' . urlencode($_GET['dir']));
      }
    }
  } elseif ($_GET['action'] == 'update') {
    // Updatekontrolle durchfhren
    $online_version = file_get_contents('http://pr0g.net/php_scripte/pwebftp/version.txt');
    $online_version_n = str_replace('.', '', $online_version);
    if (strlen($online_version_n) > 3) {
      echo '<b>Bei der Versionkontrolle trat ein Fehler auf!</b><br /><br />Eventuell ist der Zielserver momentan nicht erreichbar. Bitte versuchen Sie es zu einem sp&auml;teren Zeitpunkt erneut!';
    } else {
      $version_n = str_replace('.', '', $version);
      if ($version_n < $online_version_n) {
        echo '<span style="color:#FF0000"><b>Ihre Version ' . $version . ' von pWebFTP ist nicht auf dem neusten Stand!</b></span><br /><br />Sie sollten die neue Version ' . $online_version . ' herunterladen und installieren: <a href="http://pr0g.net/go/php_scripte/#pwebftp" target="_blank">Downloadseite &ouml;ffnen</a>.';
      } else {
        echo '<span style="color:#008000"><b>Ihre Version ' . $version . ' von pWebFTP ist auf dem aktuellesten Stand!</b></span><br /><br />Es ist momentan keine neuere Version verf&uuml;gbar.';
      }
    }
  } else {
    // Sortierungslink ermitteln
    function GetSortLink($name, $title) {
      if ($_GET['sort'] == $name) {
        $sort_order = ($_GET['sort_order'] == 'desc' ? '' : '&amp;sort_order=desc');
      } else {
        $sort_order = ($_GET['sort_order'] == 'desc' ? '&amp;sort_order=desc' : '');
      }
      $link = '<a href="?dir=' . urlencode($_GET['dir']) . '&amp;sort=' . $name . $sort_order . '">' . $title . '</a>';
      if ($_GET['sort'] == $name) {
        $link .= ' <img src="gfx/arrow_' . ($_GET['sort_order'] == 'desc' ? 'up' : 'down') . '.gif" alt="" />';
      }
      return $link;
    }
  
    if (empty($_GET['sort'])) {
      $_GET['sort'] = 'name';
    }
?>
 <table class="tbl_explorer">
 <tr class="tr_explorer_head">
  <td>&nbsp;</td><td><?=GetSortLink('name', 'Name')?></td><td style="text-align:right"><?=GetSortLink('size', 'Gr&ouml;&szlig;e')?></td><td><?=GetSortLink('type', 'Typ')?></td><td><?=GetSortLink('lc', 'Ge&auml;ndert am')?></td><td style="text-align:right">Optionen</td>
 </tr>
<?php
    // Dateigre formatieren
    function FormatFileSize($size) {
      $formats = array('B', 'KB', 'MB', 'GB');
      $count_formats = count($formats) - 1;
      $index = 0;
      while ($size >= 1024 && $index < $count_formats) {
        $size /= 1024;
        $index++;
      }
      return round($size, 2) . '&nbsp;'. $formats[$index];
    }
    
    // Alle Infos der Datei ermitteln
    function GetFileInfo($file) {
      global $file_types;

      $data = array();

      // Dateisymbol
      $data['ext'] = GetFileExt($file);
      $data['symbol'] = GetFileSymbol($data['ext']);

      // Dateigre
      $data['size'] = filesize($file);
      $data['rsize'] = FormatFileSize($data['size']);

      // Dateityp
      $data['type'] = $file_types[$data['ext']][0];
      if (empty($data['type'])) {
        $data['type'] = strtoupper($data['ext']) . '-Datei';
      }

      // nderungsdatum
      $data['lc'] = filectime($file);
      $data['rlc'] = date('d.m.Y H:i', $data['lc']);

      return $data;
    }

    // Alle Dateien auflisten
    $files = array();
    $dir = $root_dir . '/' . $_GET['dir'] . '/';
    if ($dh = @opendir($dir)) {
      while ($file = readdir($dh)) {
        if (is_file($dir . $file) && $file != '.' && $file != '..') {
          $data = GetFileInfo($dir . $file);
          $data['rname'] = $file;
          $data['name'] = strtolower($file);
          $data['readonly'] = in_array($data['rname'], $readonly);
          $files[] = $data;
        }
      }
      closedir($dh);
    }
    $files_size = 0;
    $file_count = count($files);
    if ($file_count > 0) {
      if ($_GET['sort_order'] == 'desc') {
        $sort_order = SORT_DESC;
      } else {
        $sort_order = SORT_ASC;
      }
      foreach($files as $entry)
        $sorting[] = $entry[$_GET['sort']];
      array_multisort($sorting, $sort_order, $files);
      for ($i = 0; $i < $file_count; $i++) {
        $options = '';
        $files_size += $files[$i]['size'];
        if (in_array(GetFileExt($files[$i]['rname']), $files_texts)) {
           $link = '?dir=' . urlencode($_GET['dir']) . '&amp;file=' . urlencode($files[$i]['rname']) . '&amp;action=show_source';
          $options .= '<a href="' . ($open_popup ? 'javascript:popup(\'' . $link . '\')' : $link . '" target="_blank') . '"><img src="gfx/file_showsource.gif" title="Sourcecode anzeigen" alt="" /></a> ';
          if (!$files[$i]['readonly']) {
            $options .= '<a href="?dir=' . urlencode($_GET['dir']) . '&amp;file=' . urlencode($files[$i]['rname']) . '&amp;action=edit_file"><img src="gfx/file_edit.gif" title="Datei bearbeiten" alt="" /></a> ';
          }
        }
        if (!$files[$i]['readonly']) {
          $options .= '<a href="?dir=' . urlencode($_GET['dir']) . '&amp;file=' . urlencode($files[$i]['rname']) . '&amp;action=rename_file"><img src="gfx/file_rename.gif" title="Datei umbenennen" alt="" /></a> ';
          $options .= '<a href="?dir=' . urlencode($_GET['dir']) . '&amp;selfiles[]=' . urlencode($files[$i]['rname']) . '&amp;action=file_move_delete&amp;send_move=1"><img src="gfx/file_move.gif" title="Datei verschieben" alt="" /></a>';
          $options .= '<a href="?dir=' . urlencode($_GET['dir']) . '&amp;selfiles[]=' . urlencode($files[$i]['rname']) . '&amp;action=file_move_delete&amp;send_delete=1"><img src="gfx/file_delete.gif" title="Datei l&ouml;schen" alt="" /></a>';
        }
        $link = '?dir=' . $_GET['dir'] . '&amp;file=' . urlencode($files[$i]['rname']);
        echo '<tr class="tr_explorer' . ($i % 2 == 0 ? 1 : 2) . '"><td>' . ($files[$i]['readonly'] ? '&nbsp;' : '<input type="checkbox" name="selfiles[]" value="' . $files[$i]['rname'] . '" />') . '</td><td><img src="gfx/files/' . $files[$i]['symbol'] . '" alt="" /> <a href="' . ($open_popup ? 'javascript:popup(\'' . $link . '\')' : $link . '" target="_blank') . '">' . $files[$i]['rname'] . '</a></td><td style="text-align:right">' . $files[$i]['rsize'] . '</td><td>' . $files[$i]['type'] . '</td><td>' . $files[$i]['rlc'] . '</td><td style="text-align:right">' . $options . '</td></tr>';
      }
    }
    echo '<tr class="tr_explorer_head"><td colspan="6">Insgesamt: ' . $file_count . ' Datei' . ($file_count == 1 ? '' : 'en') . ' (' . FormatFileSize($files_size) . ')</tr>';
?>
 </table>
<?php
  }
?>
 </td>
</tr>
<tr>
 <td class="td_uplink">
   <a href="#top">nach oben</a><br />
   <br />
   <span class="copyright">&copy; 2005 - 2006 <a href="http://pr0g.net" target="_parent">pr0g.net</a></span>
 </td>
</tr>
</table>
<?php
  if ($noaction) {
    echo '</form>';
  }
?>
</body>
</html>
<?php
  // Ausgabepuffer senden
  ob_end_flush();
?>